#ifndef __STC15F104E_H__
#define __STC15F104E_H__

/////////////////////////////////////////////////

//ͷļ,ٰ"REG51.H"

sfr         P0          =           0x80;
    sbit    P00         =           P0^0;
    sbit    P01         =           P0^1;
    sbit    P02         =           P0^2;
    sbit    P03         =           P0^3;
    sbit    P04         =           P0^4;
    sbit    P05         =           P0^5;
    sbit    P06         =           P0^6;
    sbit    P07         =           P0^7;

sfr         SP          =           0x81;
sfr         DPL         =           0x82;
sfr         DPH         =           0x83;
sfr         S4CON       =           0x84;
sfr         S4BUF       =           0x85;
sfr         PCON        =           0x87;

sfr         TCON        =           0x88;
    sbit    TF1         =           TCON^7;
    sbit    TR1         =           TCON^6;
    sbit    TF0         =           TCON^5;
    sbit    TR0         =           TCON^4;
    sbit    IE1         =           TCON^3;
    sbit    IT1         =           TCON^2;
    sbit    IE0         =           TCON^1;
    sbit    IT0         =           TCON^0;

sfr         TMOD        =           0x89;
sfr         TL0         =           0x8A;
sfr         TL1         =           0x8B;
sfr         TH0         =           0x8C;
sfr         TH1         =           0x8D;
sfr         AUXR        =           0x8E;
sfr         INT_CLKO    =           0x8F;

sfr         P1          =           0x90;
    sbit    P10         =           P1^0;
    sbit    P11         =           P1^1;
    sbit    P12         =           P1^2;
    sbit    P13         =           P1^3;
    sbit    P14         =           P1^4;
    sbit    P15         =           P1^5;
    sbit    P16         =           P1^6;
    sbit    P17         =           P1^7;
                        
sfr         P1M1        =           0x91;
sfr         P1M0        =           0x92;
sfr         P0M1        =           0x93;
sfr         P0M0        =           0x94;
sfr         P2M1        =           0x95;
sfr         P2M0        =           0x96;
sfr         CLK_DIV     =           0x97;

sfr         SCON        =           0x98;
    sbit    SM0         =           SCON^7;
    sbit    SM1         =           SCON^6;
    sbit    SM2         =           SCON^5;
    sbit    REN         =           SCON^4;
    sbit    TB8         =           SCON^3;
    sbit    RB8         =           SCON^2;
    sbit    TI          =           SCON^1;
    sbit    RI          =           SCON^0;

sfr         SBUF        =           0x99;
sfr         S2CON       =           0x9A;
sfr         S2BUF       =           0x9B;
sfr         P1ASF       =           0x9D;

sfr         P2          =           0xA0;
    sbit    P20         =           P2^0;
    sbit    P21         =           P2^1;
    sbit    P22         =           P2^2;
    sbit    P23         =           P2^3;
    sbit    P24         =           P2^4;
    sbit    P25         =           P2^5;
    sbit    P26         =           P2^6;
    sbit    P27         =           P2^7;

sfr         BUS_SPEED   =           0xA1;
sfr         AUXR1       =           0xA2;
sfr         P_SW1       =           0xA2;

sfr         IE          =           0xA8;
    sbit    EA          =           IE^7;
    sbit    ELVD        =           IE^6;
    sbit    EADC        =           IE^5;
    sbit    ES          =           IE^4;
    sbit    ET1         =           IE^3;
    sbit    EX1         =           IE^2;
    sbit    ET0         =           IE^1;
    sbit    EX0         =           IE^0;
    
sfr         SADDR       =           0xA9;
sfr         WKTCL       =           0xAA;
sfr         WKTCH       =           0xAB;
sfr         S3CON       =           0xAC;
sfr         S3BUF       =           0xAD;
sfr         IE2         =           0xAF;

sfr         P3          =           0xB0;
    sbit    P30         =           P3^0;
    sbit    P31         =           P3^1;
    sbit    P32         =           P3^2;
    sbit    P33         =           P3^3;
    sbit    P34         =           P3^4;
    sbit    P35         =           P3^5;
    sbit    P36         =           P3^6;
    sbit    P37         =           P3^7;

    sbit    RD          =           P3^7;
    sbit    WR          =           P3^6;
    sbit    T1          =           P3^5;
    sbit    T0          =           P3^4;
    sbit    INT1        =           P3^3;
    sbit    INT0        =           P3^2;
    sbit    TXD         =           P3^1;
    sbit    RXD         =           P3^0;
                        
sfr         P3M1        =           0xB1;
sfr         P3M0        =           0xB2;
sfr         P4M1        =           0xB3;
sfr         P4M0        =           0xB4;
sfr         IP2         =           0xB5;

sfr         IP          =           0xB8;
    sbit    PPCA        =           IP^7;
    sbit    PLVD        =           IP^6;
    sbit    PADC        =           IP^5;
    sbit    PS          =           IP^4;
    sbit    PT1         =           IP^3;
    sbit    PX1         =           IP^2;
    sbit    PT0         =           IP^1;
    sbit    PX0         =           IP^0;

sfr         SADEN       =           0xB9;
sfr         P_SW2       =           0xBA;
sfr         IRC_CLKO    =           0xBB;
sfr         ADC_CONTR   =           0xBC;
sfr         ADC_RES     =           0xBD;
sfr         ADC_RESL    =           0xBE;

sfr         P4          =           0xC0;
    sbit    P40         =           P4^0;
    sbit    P41         =           P4^1;
    sbit    P42         =           P4^2;
    sbit    P43         =           P4^3;
    sbit    P44         =           P4^4;
    sbit    P45         =           P4^5;
    sbit    P46         =           P4^6;
    sbit    P47         =           P4^7;

sfr         WDT_CONTR   =           0xC1;
sfr         IAP_DATA    =           0xC2;
sfr         IAP_ADDRH   =           0xC3;
sfr         IAP_ADDRL   =           0xC4;
sfr         IAP_CMD     =           0xC5;
sfr         IAP_TRIG    =           0xC6;
sfr         IAP_CONTR   =           0xC7;

sfr         P5          =           0xC8;
    sbit    P50         =           P5^0;
    sbit    P51         =           P5^1;
    sbit    P52         =           P5^2;
    sbit    P53         =           P5^3;
    sbit    P54         =           P5^4;
    sbit    P55         =           P5^5;
    sbit    P56         =           P5^6;
    sbit    P57         =           P5^7;
                        
sfr         P5M1        =           0xC9;
sfr         P5M0        =           0xCA;
sfr         P6M1        =           0xCB;
sfr         P6M0        =           0xCC;
sfr         SPSTAT      =           0xCD;
sfr         SPCTL       =           0xCE;
sfr         SPDAT       =           0xCF;

sfr         PSW         =           0xD0;
    sbit    CY          =           PSW^7;
    sbit    AC          =           PSW^6;
    sbit    F0          =           PSW^5;
    sbit    RS1         =           PSW^4;
    sbit    RS0         =           PSW^3;
    sbit    OV          =           PSW^2;
    sbit    F1          =           PSW^1;
    sbit    P           =           PSW^0;
                        
sfr         T4T3M       =           0xD1;
sfr         T4H         =           0xD2;
sfr         T4L         =           0xD3;
sfr         T3H         =           0xD4;
sfr         T3L         =           0xD5;
sfr         T2H         =           0xD6;
sfr         T2L         =           0xD7;

sfr         T3T4M       =           0xD1;
sfr         TH4         =           0xD2;
sfr         TL4         =           0xD3;
sfr         TH3         =           0xD4;
sfr         TL3         =           0xD5;
sfr         TH2         =           0xD6;
sfr         TL2         =           0xD7;

sfr         CCON        =           0xD8;
    sbit    CF          =           CCON^7;
    sbit    CR          =           CCON^6;
    sbit    CCF2        =           CCON^2;
    sbit    CCF1        =           CCON^1;
    sbit    CCF0        =           CCON^0;

sfr         CMOD        =           0xD9;
sfr         CCAPM0      =           0xDA;
sfr         CCAPM1      =           0xDB;
sfr         CCAPM2      =           0xDC;

sfr         ACC         =           0xE0;

sfr         P7M1        =           0xE1;
sfr         P7M0        =           0xE2;

sfr         CMPCR1      =           0xE6;
sfr         CMPCR2      =           0xE7;
                        
sfr         P6          =           0xE8;
    sbit    P60         =           P6^0;
    sbit    P61         =           P6^1;
    sbit    P62         =           P6^2;
    sbit    P63         =           P6^3;
    sbit    P64         =           P6^4;
    sbit    P65         =           P6^5;
    sbit    P66         =           P6^6;
    sbit    P67         =           P6^7;
    
sfr         CL          =           0xE9;
sfr         CCAP0L      =           0xEA;
sfr         CCAP1L      =           0xEB;
sfr         CCAP2L      =           0xEC;

sfr         B           =           0xF0;

sfr         PWMCFG      =           0xF1;
sfr         PCA_PWM0    =           0xF2;
sfr         PCA_PWM1    =           0xF3;
sfr         PCA_PWM2    =           0xF4;
sfr         PWMCR       =           0xF5;
sfr         PWMIF       =           0xF6;
sfr         PWMFDCR     =           0xF7;
                        
sfr         P7          =           0xF8;
    sbit    P70         =           P7^0;
    sbit    P71         =           P7^1;
    sbit    P72         =           P7^2;
    sbit    P73         =           P7^3;
    sbit    P74         =           P7^4;
    sbit    P75         =           P7^5;
    sbit    P76         =           P7^6;
    sbit    P77         =           P7^7;

sfr         CH          =           0xF9;
sfr         CCAP0H      =           0xFA;
sfr         CCAP1H      =           0xFB;
sfr         CCAP2H      =           0xFC;










//ں⹦ܼĴ        // λֵ   

//I/O ⹦ܼĴ
sfr P6          =   0xE8;   //0000,0000 ˿6
sbit P60        =   P6^0;
sbit P61        =   P6^1;
sbit P62        =   P6^2;
sbit P63        =   P6^3;
sbit P64        =   P6^4;
sbit P65        =   P6^5;
sbit P66        =   P6^6;
sbit P67        =   P6^7;
sfr P7          =   0xF8;   //0000,0000 ˿7
sbit P70        =   P7^0;
sbit P71        =   P7^1;
sbit P72        =   P7^2;
sbit P73        =   P7^3;
sbit P74        =   P7^4;
sbit P75        =   P7^5;
sbit P76        =   P7^6;
sbit P77        =   P7^7;
sfr P0M0        =   0x94;   //0000,0000 ˿0ģʽĴ0
sfr P0M1        =   0x93;   //0000,0000 ˿0ģʽĴ1
sfr P1M0        =   0x92;   //0000,0000 ˿1ģʽĴ0
sfr P1M1        =   0x91;   //0000,0000 ˿1ģʽĴ1
sfr P2M0        =   0x96;   //0000,0000 ˿2ģʽĴ0
sfr P2M1        =   0x95;   //0000,0000 ˿2ģʽĴ1
sfr P3M0        =   0xB2;   //0000,0000 ˿3ģʽĴ0
sfr P3M1        =   0xB1;   //0000,0000 ˿3ģʽĴ1
sfr P4M0        =   0xB4;   //0000,0000 ˿4ģʽĴ0
sfr P4M1        =   0xB3;   //0000,0000 ˿4ģʽĴ1
sfr P5M0        =   0xCA;   //0000,0000 ˿5ģʽĴ0
sfr P5M1        =   0xC9;   //0000,0000 ˿5ģʽĴ1
sfr P6M0        =   0xCC;   //0000,0000 ˿6ģʽĴ0
sfr P6M1        =   0xCB;   //0000,0000 ˿6ģʽĴ1
sfr P7M0        =   0xE2;   //0000,0000 ˿7ģʽĴ0
sfr P7M1        =   0xE1;   //0000,0000 ˿7ģʽĴ1

//ϵͳ⹦ܼĴ
sfr P_SW1       =   0xA2;   //0000,0000 ˿лĴ1
sfr CLK_DIV     =   0x97;   //xxxx,x000 ʱӷƵƼĴ
sfr BUS_SPEED   =   0xA1;   //xx10,x011 ٶȿƼĴ
sfr P1ASF       =   0x9D;   //0000,0000 ˿1ģ⹦üĴ
sfr P_SW2       =   0xBA;   //0000,0000 ˿лĴ
sfr IRC_CLKO    =   0xBB;   //0000,0000 ڲʱƼĴ

//ж⹦ܼĴ
sfr IE2         =   0xAF;   //0000,0000 жϿƼĴ2
sfr IP2         =   0xB5;   //xxxx,xx00 жȼĴ2
sfr INT_CLKO    =   0x8F;   //0000,0000 ⲿжʱƼĴ

//ʱ⹦ܼĴ
sfr T4T3M       =   0xD1;   //0000,0000 T3/T4ģʽĴ
sfr T3T4M       =   0xD1;   //0000,0000 T3/T4ģʽĴ
sfr T4H         =   0xD2;   //0000,0000 T4ֽ
sfr T4L         =   0xD3;   //0000,0000 T4ֽ
sfr T3H         =   0xD4;   //0000,0000 T3ֽ
sfr T3L         =   0xD5;   //0000,0000 T3ֽ
sfr T2H         =   0xD6;   //0000,0000 T2ֽ
sfr T2L         =   0xD7;   //0000,0000 T2ֽ
sfr TH4         =   0xD2;   //0000,0000 T4ֽ
sfr TL4         =   0xD3;   //0000,0000 T4ֽ
sfr TH3         =   0xD4;   //0000,0000 T3ֽ
sfr TL3         =   0xD5;   //0000,0000 T3ֽ
sfr TH2         =   0xD6;   //0000,0000 T2ֽ
sfr TL2         =   0xD7;   //0000,0000 T2ֽ
sfr WKTCL       =   0xAA;   //0000,0000 绽Ѷʱֽ
sfr WKTCH       =   0xAB;   //0000,0000 绽Ѷʱֽ

//п⹦ܼĴ
sfr S2CON       =   0x9A;   //0000,0000 2ƼĴ
sfr S2BUF       =   0x9B;   //xxxx,xxxx 2ݼĴ
sfr S3CON       =   0xAC;   //0000,0000 3ƼĴ
sfr S3BUF       =   0xAD;   //xxxx,xxxx 3ݼĴ
sfr S4CON       =   0x84;   //0000,0000 4ƼĴ
sfr S4BUF       =   0x85;   //xxxx,xxxx 4ݼĴ

//ADC ⹦ܼĴ
sfr ADC_CONTR   =   0xBC;   //0000,0000 A/DתƼĴ
sfr ADC_RES     =   0xBD;   //0000,0000 A/Dת8λ
sfr ADC_RESL    =   0xBE;   //0000,0000 A/Dת2λ

//SPI ⹦ܼĴ
sfr SPSTAT      =   0xCD;   //00xx,xxxx SPI״̬Ĵ
sfr SPCTL       =   0xCE;   //0000,0100 SPIƼĴ
sfr SPDAT       =   0xCF;   //0000,0000 SPIݼĴ


/////////////////////////////////////////////////

#endif

